// MiyaCalibView.cpp : CMiyaCalibView NX̎
//

#include "stdafx.h"
#include "MiyaCalib.h"

#include "MiyaCalibDoc.h"
#include "MiyaCalibView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMiyaCalibView

IMPLEMENT_DYNCREATE(CMiyaCalibView, CView)

BEGIN_MESSAGE_MAP(CMiyaCalibView, CView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_EXEC_2D, &CMiyaCalibView::OnExec2d)
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_EXEC_POS, &CMiyaCalibView::OnExecPos)
	ON_COMMAND(ID_EXEC_3D, &CMiyaCalibView::OnExec3d)
	ON_COMMAND(ID_EXEC_CALIB, &CMiyaCalibView::OnExecCalib)
	ON_COMMAND(ID_EXEC_OPEN, &CMiyaCalibView::OnExecOpen)
	ON_COMMAND(ID_EXEC_TARGET, &CMiyaCalibView::OnExecTarget)
	ON_COMMAND(ID_EXEC_SAVE, &CMiyaCalibView::OnExecSave)
	ON_COMMAND(ID_DEBUG_TEST1, &CMiyaCalibView::OnDebugTest1)
	ON_COMMAND(ID_DEBUG_TEST2, &CMiyaCalibView::OnDebugTest2)
END_MESSAGE_MAP()

// CMiyaCalibView RXgNV/fXgNV

CMiyaCalibView::CMiyaCalibView()
{
	int i;

	// TODO: \zR[hɒǉ܂B
	PROCESSMAX = 100;
	CORRESMAX = 12;
	POINT3DMAX = 16770000;

	point3d = NULL;
	screendata = NULL;
	processdone = NULL;
	corres2d = NULL;
	corres3d = NULL;
	point3dproj = NULL;
	imagedata = NULL;
	intrinsic_matrix = NULL;
	processdone = new bool[PROCESSMAX];
	corres2d = new int[CORRESMAX * 2];
	corres3d = new int[CORRESMAX * 2];
	intrinsic_matrix = cvCreateMat(3, 3, CV_64FC1);
	if(processdone == NULL ||
		corres2d == NULL ||
		corres3d == NULL ||
		intrinsic_matrix == NULL) AfxMessageBox("܂");

	SIZEX = 0;
	SIZEY = 0;
	point3dnum = 0;
	MIYA_INTRINSIC = 0;
	MIYA_IMAGE = 1;
	MIYA_GEOMETRY = 2;
	MIYA_2D = 3;
	MIYA_POS = 4;
	MIYA_3D = 5;
	MIYA_CALIB = 6;
	viewmode = 0;
	PI = 3.1415926535897932384626433832795;
	EPS = 1.0e-15;
	buttondown = false;
	corres2dnum = 0;
	corres3dnum = 0;
	prevpoint.x = prevpoint.y = 0;
	centerx = centery = centerz = 0.0;
	scale = 1.0;
	viewscale = 1.0;
	for(i = 0; i < PROCESSMAX; i++) processdone[i] = false;
	for(i = 0; i < 16; i++) modelview[i] = 0.0;
	modelview[0] = modelview[5] = modelview[10] = modelview[15] = 1.0;
}

CMiyaCalibView::~CMiyaCalibView()
{
}

BOOL CMiyaCalibView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

// CMiyaCalibView `

void CMiyaCalibView::OnDraw(CDC* pDC)
{
	CMiyaCalibDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	CBitmap bitmap;
	CDC dcMemory;
	int w, h;
	int dstw, dsth;
	int i;
	int x, y;
	RECT rect;
	CBrush brush;

	if(!processdone[viewmode]) return;
	if(screendata == NULL || SIZEX == 0 || SIZEY == 0) return;

	// ̂̉摜\
	w = SIZEX;
	h = SIZEY;
	dstw = (int)floor((double)SIZEX * viewscale + 0.5);
	dsth = (int)floor((double)SIZEY * viewscale + 0.5);
	bitmap.CreateCompatibleBitmap(pDC, w, h);
	bitmap.SetBitmapBits(w * h * 4, screendata);
	dcMemory.CreateCompatibleDC(pDC);
	dcMemory.SelectObject(&bitmap);
	pDC->StretchBlt(0, 0, dstw, dsth, &dcMemory, 0, 0, w, h, SRCCOPY);
	bitmap.DeleteObject();
	dcMemory.DeleteDC();

	// }[J[\
	brush.CreateSolidBrush(RGB(255,0,0));
	if(viewmode == MIYA_2D) {
		for(i = 0; i < corres2dnum; i++) {
			x = corres2d[i*2 + 0];
			y = corres2d[i*2 + 1];
			x = (int)floor((double)x * viewscale + 0.5);
			y = (int)floor((double)y * viewscale + 0.5);
			rect.top = y - 2;
			rect.bottom = y + 2;
			rect.left = x - 2;
			rect.right = x + 2;
			pDC->FillRect(&rect, &brush);
		}
	}
	if(viewmode == MIYA_3D) {
		for(i = 0; i < corres3dnum; i++) {
			x = corres3d[i*2 + 0];
			y = corres3d[i*2 + 1];
			rect.top = y - 2;
			rect.bottom = y + 2;
			rect.left = x - 2;
			rect.right = x + 2;
			pDC->FillRect(&rect, &brush);
		}
	}
	brush.DeleteObject();
}


// CMiyaCalibView ff

#ifdef _DEBUG
void CMiyaCalibView::AssertValid() const
{
	CView::AssertValid();
}

void CMiyaCalibView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMiyaCalibDoc* CMiyaCalibView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMiyaCalibDoc)));
	return (CMiyaCalibDoc*)m_pDocument;
}
#endif //_DEBUG


// CMiyaCalibView bZ[W nh

void CMiyaCalibView::CreateImages(void)
{
	int x, y;
	int i;
	int r, g, b;

	// f[^`FbN
	if(!processdone[viewmode]) return;

	// 
	if(screendata == NULL || SIZEX == 0 || SIZEY == 0) return;
	for(i = 0; i < 4 * SIZEX * SIZEY; i++) screendata[i] = 0;

	// 摜f[^쐬
	if(viewmode == MIYA_2D) {
		for(y = 0; y < SIZEY; y++) {
			for(x = 0; x < SIZEX; x++) {
				r = (int)imagedata[y*SIZEX*3 + x*3 + 0];
				g = (int)imagedata[y*SIZEX*3 + x*3 + 1];
				b = (int)imagedata[y*SIZEX*3 + x*3 + 2];
				screendata[SIZEX*4*y + 4*x + 0] = (unsigned char)b;
				screendata[SIZEX*4*y + 4*x + 1] = (unsigned char)g;
				screendata[SIZEX*4*y + 4*x + 2] = (unsigned char)r;
				screendata[SIZEX*4*y + 4*x + 3] = (unsigned char)0;
			}
		}
	}
	if(viewmode == MIYA_POS) RenderImages(true);
	if(viewmode == MIYA_3D) RenderImages(true);
	if(viewmode == MIYA_CALIB) SynthesizeImages();
}

void CMiyaCalibView::RenderImages(bool memorybuffer)
{
	CDC dcMemory;
	HGLRC m_hRC;
	HBITMAP hBitmap;
	BITMAPINFO bmInfo;
	UINT usage;
	unsigned char *bitdata;
	int i;
	int x, y;
	int j;
	int r, g, b;

	dcMemory.CreateCompatibleDC(this->GetDC());
	bmInfo.bmiHeader.biSize = sizeof(bmInfo.bmiHeader);
	bmInfo.bmiHeader.biWidth = SIZEX;
	bmInfo.bmiHeader.biHeight = SIZEY;
	bmInfo.bmiHeader.biPlanes = 1;
	bmInfo.bmiHeader.biBitCount = 24;
	bmInfo.bmiHeader.biXPelsPerMeter = 0;
	bmInfo.bmiHeader.biYPelsPerMeter = 0;
	bmInfo.bmiHeader.biClrUsed = 0;
	bmInfo.bmiHeader.biClrImportant = 0;
	bmInfo.bmiHeader.biCompression = BI_RGB;
	bmInfo.bmiHeader.biSizeImage = 0;
	usage = DIB_RGB_COLORS;
	hBitmap = CreateDIBSection(dcMemory.GetSafeHdc(), &bmInfo, usage, (void**)&bitdata, NULL, 0);
	SelectObject(dcMemory.GetSafeHdc(), hBitmap);

	PIXELFORMATDESCRIPTOR pfd = 
	{
		sizeof (PIXELFORMATDESCRIPTOR),				// TCY
		1,
		PFD_DRAW_TO_BITMAP | PFD_SUPPORT_OPENGL,	// tO
		PFD_TYPE_RGBA,								// J[f[^
		24,											// rbg
		0, 0, 0, 0, 0, 0, 0, 0,						// Œ: RGBÃrbg
		0, 0, 0, 0,	0,								// AL~[Vobt@̃rbg(A`GCAXp)
		16,											// fvXobt@̃rbg (32bitƒx)
		0, 0,										// Œ: XeVE⏕obt@
		PFD_MAIN_PLANE,								// : 僌C^Cv
		0, 0, 0, 0,									// Œ
	};
	int nPixelFormat = ChoosePixelFormat(dcMemory.GetSafeHdc(), &pfd);
	BOOL bSuccess = SetPixelFormat(dcMemory.GetSafeHdc(), nPixelFormat, &pfd);

	m_hRC = ::wglCreateContext(dcMemory.GetSafeHdc());

	// OpenGL R}h𔭍sOɂ͂Ă
	::wglMakeCurrent(dcMemory.GetSafeHdc(), m_hRC);

	// r[|[g̐ݒ
	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
	::gluPerspective(40.0, (double)SIZEX / (double)SIZEY, 0.01, 30.0);
	::glViewport(0, 0, SIZEX, SIZEY);
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity();
	::glTranslated(0.0, 0.0, -10.0);
	::glMultMatrixd(modelview);
	::glScaled(1.0 / scale, 1.0 / scale, 1.0 / scale);
	::glTranslated(-centerx, -centery, -centerz);

	// 
	::glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	::glClearDepth(1.0f);
	::glEnable(GL_DEPTH_TEST);
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
	// ̑̐ݒ
	::glDisable(GL_LIGHTING);

	// `
	::glBegin(GL_POINTS);
	::glColor3d(1.0, 1.0, 1.0);
	for(i = 0; i < point3dnum; i++) {
		::glVertex3d(point3d[i*3 + 0], point3d[i*3 + 1], point3d[i*3 + 2]);
	}
	::glEnd();
	
	::glFinish();

	::glDisable(GL_DEPTH_TEST);
	::glDisable(GL_LIGHTING);

	// OpenGL R}h𔭍sI炱Ă
	::wglMakeCurrent(dcMemory.GetSafeHdc(), 0);

	if(memorybuffer) {
		// 摜f[^Rs[
		for(y = 0; y < SIZEY; y++) {
			for(x = 0; x < SIZEX; x++) {
				i = (SIZEY - 1 - y) * (SIZEX*3 + (4-(SIZEX*3)%4)%4) + x * 3;
				j = 4*SIZEX*y + 4*x;
				b = bitdata[i + 0];
				g = bitdata[i + 1];
				r = bitdata[i + 2];
				screendata[j + 0] = b;
				screendata[j + 1] = g;
				screendata[j + 2] = r;
				screendata[j + 3] = 0;
			}
		}
	} else {
		// ʕ`
		this->GetDC()->BitBlt(0, 0, SIZEX, SIZEY, &dcMemory, 0, 0, SRCCOPY);
	}

	// 
	::wglDeleteContext(m_hRC);
	DeleteObject(hBitmap);
	dcMemory.DeleteDC();
}

void CMiyaCalibView::OnExec2d()
{
	processdone[MIYA_2D] = true;
	viewmode = MIYA_2D;
	CreateImages();
	Invalidate();
}

void CMiyaCalibView::OnLButtonDown(UINT nFlags, CPoint point)
{
	prevpoint = point;
	if(viewmode == MIYA_POS) buttondown = true;
	if(viewmode == MIYA_2D) buttondown = true;

	CView::OnLButtonDown(nFlags, point);
}

void CMiyaCalibView::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(buttondown && viewmode == MIYA_POS) {
		CreateImages();
		Invalidate(false);
	}
	if(buttondown && viewmode == MIYA_2D) {
		Invalidate();
	}
	buttondown = false;

	CView::OnLButtonUp(nFlags, point);
}

void CMiyaCalibView::OnRButtonDown(UINT nFlags, CPoint point)
{
	int x, y;
	if(viewmode == MIYA_2D) {
		x = point.x;
		y = point.y;
		x = (int)floor((double)x / viewscale + 0.5);
		y = (int)floor((double)y / viewscale + 0.5);
		if(x >= 0 && y >= 0 && x < SIZEX && y < SIZEY) {
			if(corres2dnum >= CORRESMAX) corres2dnum = CORRESMAX - 1;
			corres2d[corres2dnum * 2 + 0] = x;
			corres2d[corres2dnum * 2 + 1] = y;
			corres2dnum++;
			CreateImages();
			Invalidate(false);
		}
	}
	if(viewmode == MIYA_3D) {
		if(point.x >= 0 && point.y >= 0 && point.x < SIZEX && point.y < SIZEY) {
			if(corres3dnum >= CORRESMAX) corres3dnum = CORRESMAX - 1;
			corres3d[corres3dnum * 2 + 0] = point.x;
			corres3d[corres3dnum * 2 + 1] = point.y;
			corres3dnum++;
			CreateImages();
			Invalidate(false);
		}
	}

	CView::OnRButtonDown(nFlags, point);
}

void CMiyaCalibView::OnRButtonUp(UINT nFlags, CPoint point)
{
	CView::OnRButtonUp(nFlags, point);
}

void CMiyaCalibView::OnMouseMove(UINT nFlags, CPoint point)
{
	int dx, dy;
	const double XYSPEED = 0.01;
	const double ZSPEED = 0.1;
	const double RSPEED = 0.01;
	static double mat[9];
	static double old[9];
	double angle;
	double vx, vy, vz;
	double val;
	const double SCALESPEED = 0.01;
	const double SCALEMIN = 0.1;
	const double SCALEMAX = 4.0;

	// }EX̓vZ
	dx = point.x - prevpoint.x;
	dy = point.y - prevpoint.y;
	dy = -dy;

	if(buttondown && viewmode == MIYA_2D) {
		if(nFlags & MK_CONTROL) {
			viewscale *= 1.0 + SCALESPEED * (double)dy;
			if(viewscale < SCALEMIN) viewscale = SCALEMIN;
			if(viewscale > SCALEMAX) viewscale = SCALEMAX;
			Invalidate(false);
		}
	}
	if(buttondown && viewmode == MIYA_POS) {
		if(nFlags & MK_SHIFT) {
			// xyW̑
			modelview[12] += XYSPEED * (double)dx;
			modelview[13] += XYSPEED * (double)dy;
		} else if(nFlags & MK_CONTROL) {
			// zW̑
			modelview[14] += ZSPEED * (double)dy;
		} else {
			// ]̑
			vx = -(double)dy;
			vy = (double)dx;
			vz = 0.0;
			angle = sqrt(vx * vx + vy * vy);
			if(angle > EPS) {
				vx *= RSPEED;
				vy *= RSPEED;
				angle *= RSPEED;
				mat[0*3 + 0] = -vz * vz - vy * vy; mat[0*3 + 1] = vx * vy;            mat[0*3 + 2] = vz * vx;
				mat[1*3 + 0] = vx * vy;            mat[1*3 + 1] = -vz * vz - vx * vx; mat[1*3 + 2] = vy * vz;
				mat[2*3 + 0] = vz * vx;            mat[2*3 + 1] = vy * vz;            mat[2*3 + 2] = -vy * vy - vx * vx;
				val = (1.0 - cos(angle)) / (angle * angle);
				mat[0*3 + 0] *= val; mat[0*3 + 1] *= val; mat[0*3 + 2] *= val;
				mat[1*3 + 0] *= val; mat[1*3 + 1] *= val; mat[1*3 + 2] *= val;
				mat[2*3 + 0] *= val; mat[2*3 + 1] *= val; mat[2*3 + 2] *= val;
				val = sin(angle) / angle;
				mat[0*3 + 0] += 1.0;       mat[0*3 + 1] += -vz * val; mat[0*3 + 2] +=  vy * val;
				mat[1*3 + 0] +=  vz * val; mat[1*3 + 1] += 1.0;       mat[1*3 + 2] += -vx * val;
				mat[2*3 + 0] += -vy * val; mat[2*3 + 1] +=  vx * val; mat[2*3 + 2] += 1.0;
				old[0*3 + 0] = modelview[0]; old[0*3 + 1] = modelview[4]; old[0*3 + 2] = modelview[8];
				old[1*3 + 0] = modelview[1]; old[1*3 + 1] = modelview[5]; old[1*3 + 2] = modelview[9];
				old[2*3 + 0] = modelview[2]; old[2*3 + 1] = modelview[6]; old[2*3 + 2] = modelview[10];
				modelview[ 0] = mat[0*3 + 0] * old[0*3 + 0] + mat[0*3 + 1] * old[1*3 + 0] + mat[0*3 + 2] * old[2*3 + 0];
				modelview[ 4] = mat[0*3 + 0] * old[0*3 + 1] + mat[0*3 + 1] * old[1*3 + 1] + mat[0*3 + 2] * old[2*3 + 1];
				modelview[ 8] = mat[0*3 + 0] * old[0*3 + 2] + mat[0*3 + 1] * old[1*3 + 2] + mat[0*3 + 2] * old[2*3 + 2];
				modelview[ 1] = mat[1*3 + 0] * old[0*3 + 0] + mat[1*3 + 1] * old[1*3 + 0] + mat[1*3 + 2] * old[2*3 + 0];
				modelview[ 5] = mat[1*3 + 0] * old[0*3 + 1] + mat[1*3 + 1] * old[1*3 + 1] + mat[1*3 + 2] * old[2*3 + 1];
				modelview[ 9] = mat[1*3 + 0] * old[0*3 + 2] + mat[1*3 + 1] * old[1*3 + 2] + mat[1*3 + 2] * old[2*3 + 2];
				modelview[ 2] = mat[2*3 + 0] * old[0*3 + 0] + mat[2*3 + 1] * old[1*3 + 0] + mat[2*3 + 2] * old[2*3 + 0];
				modelview[ 6] = mat[2*3 + 0] * old[0*3 + 1] + mat[2*3 + 1] * old[1*3 + 1] + mat[2*3 + 2] * old[2*3 + 1];
				modelview[10] = mat[2*3 + 0] * old[0*3 + 2] + mat[2*3 + 1] * old[1*3 + 2] + mat[2*3 + 2] * old[2*3 + 2];
			}
		}

		// ʕ`
		RenderImages(false);
	}
	prevpoint = point;

	CView::OnMouseMove(nFlags, point);
}


void CMiyaCalibView::OnExecPos()
{
	viewscale = 1.0;
	processdone[MIYA_POS] = true;
	viewmode = MIYA_POS;
	CreateImages();
	Invalidate();
}

void CMiyaCalibView::OnExec3d()
{
	processdone[MIYA_3D] = true;
	viewmode = MIYA_3D;
	CreateImages();
	Invalidate();
}

void CMiyaCalibView::OnExecCalib()
{
	CWaitCursor wait;
	CvMat* src_points;
	CvMat* dst_points;
	CvMat* homography;
	CvMat* rotation_vector;
	CvMat* translation_vector;
	CvMat* rotation_matrix;
	int inxlist;
	int plane;
	double* plane2d;
	int inx3d;
	double origx, origy;
	double projx, projy, projz;
	bool flag;
	int i;
	double ax, ay, az;
	double bx, by, bz;
	double cz;
	double* caliblist2;
	double* caliblist3;
	CvMat* object_points;
	CvMat* image_points;
	CString str;

	src_points = NULL;
	dst_points = NULL;
	homography = NULL;
	rotation_vector = NULL;
	translation_vector = NULL;
	rotation_matrix = NULL;
	plane2d = NULL;
	caliblist2 = NULL;
	caliblist3 = NULL;
	src_points = cvCreateMat(4, 2, CV_64FC1);
	dst_points = cvCreateMat(4, 2, CV_64FC1);
	homography = cvCreateMat(3, 3, CV_64FC1);
	rotation_vector = cvCreateMat(3, 1, CV_64FC1);
	translation_vector = cvCreateMat(3, 1, CV_64FC1);
	rotation_matrix = cvCreateMat(3, 3, CV_64FC1);
	plane2d = new double[4*2];
	caliblist2 = new double[point3dnum*2];
	caliblist3 = new double[point3dnum*3];
	if(src_points == NULL ||
		dst_points == NULL ||
		homography == NULL ||
		rotation_vector == NULL ||
		translation_vector == NULL ||
		rotation_matrix == NULL ||
		plane2d == NULL ||
		caliblist2 == NULL ||
		caliblist3 == NULL) {
			AfxMessageBox("܂");
			return;
	}

	CalcIndex();

	inxlist = 0;
	for(plane = 0; plane < 3; plane++) {
		// lp`ݒ
		cvmSet(src_points, 0, 0, (double)corres3d[plane*4*2 + 0*2 + 0]);
		cvmSet(src_points, 0, 1, (double)corres3d[plane*4*2 + 0*2 + 1]);
		cvmSet(src_points, 1, 0, (double)corres3d[plane*4*2 + 1*2 + 0]);
		cvmSet(src_points, 1, 1, (double)corres3d[plane*4*2 + 1*2 + 1]);
		cvmSet(src_points, 2, 0, (double)corres3d[plane*4*2 + 2*2 + 0]);
		cvmSet(src_points, 2, 1, (double)corres3d[plane*4*2 + 2*2 + 1]);
		cvmSet(src_points, 3, 0, (double)corres3d[plane*4*2 + 3*2 + 0]);
		cvmSet(src_points, 3, 1, (double)corres3d[plane*4*2 + 3*2 + 1]);
		plane2d[0*2 + 0] = (double)corres2d[plane*4*2 + 0*2 + 0];
		plane2d[0*2 + 1] = (double)corres2d[plane*4*2 + 0*2 + 1];
		plane2d[1*2 + 0] = (double)corres2d[plane*4*2 + 1*2 + 0];
		plane2d[1*2 + 1] = (double)corres2d[plane*4*2 + 1*2 + 1];
		plane2d[2*2 + 0] = (double)corres2d[plane*4*2 + 2*2 + 0];
		plane2d[2*2 + 1] = (double)corres2d[plane*4*2 + 2*2 + 1];
		plane2d[3*2 + 0] = (double)corres2d[plane*4*2 + 3*2 + 0];
		plane2d[3*2 + 1] = (double)corres2d[plane*4*2 + 3*2 + 1];
		cvmSet(dst_points, 0, 0, plane2d[0*2 + 0]);
		cvmSet(dst_points, 0, 1, plane2d[0*2 + 1]);
		cvmSet(dst_points, 1, 0, plane2d[1*2 + 0]);
		cvmSet(dst_points, 1, 1, plane2d[1*2 + 1]);
		cvmSet(dst_points, 2, 0, plane2d[2*2 + 0]);
		cvmSet(dst_points, 2, 1, plane2d[2*2 + 1]);
		cvmSet(dst_points, 3, 0, plane2d[3*2 + 0]);
		cvmSet(dst_points, 3, 1, plane2d[3*2 + 1]);

		// zOtB[vZ
		cvFindHomography(src_points, dst_points, homography);

		// 3D_2D_̃Xg
		for(inx3d = 0; inx3d < point3dnum; inx3d++) {
			origx = (double)point3dproj[inx3d*2 + 0];
			origy = (double)point3dproj[inx3d*2 + 1];
			if(origx >= 0 && origy >= 0) {
				// Ή_vZ
				projx = cvmGet(homography, 0, 0) * origx + cvmGet(homography, 0, 1) * origy + cvmGet(homography, 0, 2);
				projy = cvmGet(homography, 1, 0) * origx + cvmGet(homography, 1, 1) * origy + cvmGet(homography, 1, 2);
				projz = cvmGet(homography, 2, 0) * origx + cvmGet(homography, 2, 1) * origy + cvmGet(homography, 2, 2);
				projx /= projz;
				projy /= projz;

				// lp`̓
				flag = true;
				for(i = 0; i < 4; i++) {
					ax = plane2d[((i+1)%4) * 2 + 0] - plane2d[i * 2 + 0];
					ay = plane2d[((i+1)%4) * 2 + 1] - plane2d[i * 2 + 1];
					az = 0.0;
					bx = projx - plane2d[i * 2 + 0];
					by = projy - plane2d[i * 2 + 1];
					bz = 0.0;
					cz = ax * by - ay * bx;
					if(cz > 0.0) flag = false;
				}

				// Xgɒǉ
				if(flag) {
					caliblist2[inxlist*2 + 0] = projx;
					caliblist2[inxlist*2 + 1] = projy;
					caliblist3[inxlist*3 + 0] = point3d[inx3d*3 + 0];
					caliblist3[inxlist*3 + 1] = point3d[inx3d*3 + 1];
					caliblist3[inxlist*3 + 2] = point3d[inx3d*3 + 2];
					inxlist++;
				}
			}
		}
	}

	// Lu[Vpf[^̃̊m
	object_points = NULL;
	image_points = NULL;
	object_points = cvCreateMat(inxlist, 3, CV_64FC1);
	image_points = cvCreateMat(inxlist, 2, CV_64FC1);
	if(object_points == NULL ||
		image_points == NULL) {
			AfxMessageBox("܂");
			return;
	}

	// Lu[Vpf[^ݒ
	for(i = 0; i < inxlist; i++) {
		cvmSet(object_points, i, 0, caliblist3[i*3 + 0]);
		cvmSet(object_points, i, 1, caliblist3[i*3 + 1]);
		cvmSet(object_points, i, 2, caliblist3[i*3 + 2]);
		cvmSet(image_points, i, 0, caliblist2[i*2 + 0]);
		cvmSet(image_points, i, 1, caliblist2[i*2 + 1]);
	}

	// Lu[V
	cvFindExtrinsicCameraParams2(object_points, image_points, intrinsic_matrix, NULL, rotation_vector, translation_vector);
	cvRodrigues2(rotation_vector, rotation_matrix);

	// Lu[Vʂۑ
	extmatgl[0] = cvmGet(rotation_matrix, 0, 0); extmatgl[4] = cvmGet(rotation_matrix, 0, 1); extmatgl[8] = cvmGet(rotation_matrix, 0, 2);
	extmatgl[1] = cvmGet(rotation_matrix, 1, 0); extmatgl[5] = cvmGet(rotation_matrix, 1, 1); extmatgl[9] = cvmGet(rotation_matrix, 1, 2);
	extmatgl[2] = cvmGet(rotation_matrix, 2, 0); extmatgl[6] = cvmGet(rotation_matrix, 2, 1); extmatgl[10] = cvmGet(rotation_matrix, 2, 2);
	extmatgl[12] = cvmGet(translation_vector, 0, 0);
	extmatgl[13] = cvmGet(translation_vector, 1, 0);
	extmatgl[14] = cvmGet(translation_vector, 2, 0);
	extmatgl[3] = 0.0; extmatgl[7] = 0.0; extmatgl[11] = 0.0; extmatgl[15] = 1.0;

	// Lu[Vʂ\
	str.Format("JOs(MODELVIEWs)\n");
	str.AppendFormat("[] | i]\n");
	str.AppendFormat("%1.3f %1.3f %1.3f %1.3f\n", cvmGet(rotation_matrix, 0, 0), cvmGet(rotation_matrix, 0, 1), cvmGet(rotation_matrix, 0, 2), cvmGet(translation_vector, 0, 0));
	str.AppendFormat("%1.3f %1.3f %1.3f %1.3f\n", cvmGet(rotation_matrix, 1, 0), cvmGet(rotation_matrix, 1, 1), cvmGet(rotation_matrix, 1, 2), cvmGet(translation_vector, 1, 0));
	str.AppendFormat("%1.3f %1.3f %1.3f %1.3f\n", cvmGet(rotation_matrix, 2, 0), cvmGet(rotation_matrix, 2, 1), cvmGet(rotation_matrix, 2, 2), cvmGet(translation_vector, 2, 0));
	AfxMessageBox(str);

	// 
	cvReleaseMat(&src_points);
	cvReleaseMat(&dst_points);
	cvReleaseMat(&homography);
	cvReleaseMat(&object_points);
	cvReleaseMat(&image_points);
	cvReleaseMat(&rotation_vector);
	cvReleaseMat(&translation_vector);
	cvReleaseMat(&rotation_matrix);
	delete [] plane2d;
	delete [] caliblist2;
	delete [] caliblist3;

	// ㏈
	processdone[MIYA_CALIB] = true;
	viewmode = MIYA_CALIB;
	CreateImages();
	Invalidate();
}

void CMiyaCalibView::CalcIndex()
{
	CDC dcMemory;
	HGLRC m_hRC;
	HBITMAP hBitmap;
	BITMAPINFO bmInfo;
	UINT usage;
	unsigned char *bitdata;
	int i;
	int x, y;
	int j;
	int r, g, b;

	dcMemory.CreateCompatibleDC(this->GetDC());
	bmInfo.bmiHeader.biSize = sizeof(bmInfo.bmiHeader);
	bmInfo.bmiHeader.biWidth = SIZEX;
	bmInfo.bmiHeader.biHeight = SIZEY;
	bmInfo.bmiHeader.biPlanes = 1;
	bmInfo.bmiHeader.biBitCount = 24;
	bmInfo.bmiHeader.biXPelsPerMeter = 0;
	bmInfo.bmiHeader.biYPelsPerMeter = 0;
	bmInfo.bmiHeader.biClrUsed = 0;
	bmInfo.bmiHeader.biClrImportant = 0;
	bmInfo.bmiHeader.biCompression = BI_RGB;
	bmInfo.bmiHeader.biSizeImage = 0;
	usage = DIB_RGB_COLORS;
	hBitmap = CreateDIBSection(dcMemory.GetSafeHdc(), &bmInfo, usage, (void**)&bitdata, NULL, 0);
	SelectObject(dcMemory.GetSafeHdc(), hBitmap);

	PIXELFORMATDESCRIPTOR pfd = 
	{
		sizeof (PIXELFORMATDESCRIPTOR),				// TCY
		1,
		PFD_DRAW_TO_BITMAP | PFD_SUPPORT_OPENGL,	// tO
		PFD_TYPE_RGBA,								// J[f[^
		24,											// rbg
		0, 0, 0, 0, 0, 0, 0, 0,						// Œ: RGBÃrbg
		0, 0, 0, 0,	0,								// AL~[Vobt@̃rbg(A`GCAXp)
		16,											// fvXobt@̃rbg (32bitƒx)
		0, 0,										// Œ: XeVE⏕obt@
		PFD_MAIN_PLANE,								// : 僌C^Cv
		0, 0, 0, 0,									// Œ
	};
	int nPixelFormat = ChoosePixelFormat(dcMemory.GetSafeHdc(), &pfd);
	BOOL bSuccess = SetPixelFormat(dcMemory.GetSafeHdc(), nPixelFormat, &pfd);

	m_hRC = ::wglCreateContext(dcMemory.GetSafeHdc());

	// OpenGL R}h𔭍sOɂ͂Ă
	::wglMakeCurrent(dcMemory.GetSafeHdc(), m_hRC);

	// r[|[g̐ݒ
	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
	::gluPerspective(40.0, (double)SIZEX / (double)SIZEY, 0.01, 30.0);
	::glViewport(0, 0, SIZEX, SIZEY);
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity();
	::glTranslated(0.0, 0.0, -10.0);
	::glMultMatrixd(modelview);
	::glScaled(1.0 / scale, 1.0 / scale, 1.0 / scale);
	::glTranslated(-centerx, -centery, -centerz);

	// 
	::glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
	::glClearDepth(1.0f);
	::glEnable(GL_DEPTH_TEST);
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
	// ̑̐ݒ
	::glDisable(GL_LIGHTING);

	// `
	::glBegin(GL_POINTS);
	for(i = 0; i < point3dnum; i++) {
		b = i & 0xff;
		g = (i >> 8) & 0xff;
		r = (i >> 16) & 0xff;
		::glColor3ub((unsigned char)r, (unsigned char)g, (unsigned char)b);
		::glVertex3d(point3d[i*3 + 0], point3d[i*3 + 1], point3d[i*3 + 2]);
	}		
	::glEnd();
	
	::glFinish();

	::glDisable(GL_DEPTH_TEST);
	::glDisable(GL_LIGHTING);

	// OpenGL R}h𔭍sI炱Ă
	::wglMakeCurrent(dcMemory.GetSafeHdc(), 0);

	// CfbNX𒲂ׂ
	for(j = 0; j < point3dnum; j++) {
		point3dproj[j * 2 + 0] = -1;
		point3dproj[j * 2 + 1] = -1;
	}
	for(y = 0; y < SIZEY; y++) {
		for(x = 0; x < SIZEX; x++) {
			i = (SIZEY - 1 - y) * (SIZEX*3 + (4-(SIZEX*3)%4)%4) + x * 3;
			b = bitdata[i + 0];
			g = bitdata[i + 1];
			r = bitdata[i + 2];
			j = r * 256 * 256 + g * 256 + b;
			if(j < point3dnum) {
				point3dproj[j * 2 + 0] = x;
				point3dproj[j * 2 + 1] = y;
			}
		}
	}

	// 
	::wglDeleteContext(m_hRC);
	DeleteObject(hBitmap);
	dcMemory.DeleteDC();
}

void CMiyaCalibView::SynthesizeImages()
{
	CDC dcMemory;
	HGLRC m_hRC;
	HBITMAP hBitmap;
	BITMAPINFO bmInfo;
	UINT usage;
	unsigned char *bitdata;
	int i;
	int x, y;
	int j;
	int r, g, b;
	double* intmatgl;
	double focalx, focaly;
	double centerx, centery;
	double glnear, glfar;
	double width, height;

	// ˉesvZ
	intmatgl = NULL;
	intmatgl = new double[16];
	if(intmatgl == NULL) {
		AfxMessageBox("܂");
		return;
	}
	focalx = cvmGet(intrinsic_matrix, 0, 0);
	focaly = cvmGet(intrinsic_matrix, 1, 1);
	centerx = cvmGet(intrinsic_matrix, 0, 2);
	centery = cvmGet(intrinsic_matrix, 1, 2);
	glnear = 0.01;
	glfar = 3000.0;
	width = (double)SIZEX;
	height = (double)SIZEY;
	intmatgl[0] = focalx * 2.0 / width;
	intmatgl[4] = 0.0;
	intmatgl[8] = centerx * 2.0 / width - 1.0;
	intmatgl[12] = 0.0;
	intmatgl[1] = 0.0;
	intmatgl[5] = -focaly * 2.0 / height;
	intmatgl[9] = -centery * 2.0 / height + 1.0;
	intmatgl[13] = 0.0;
	intmatgl[2] = 0.0;
	intmatgl[6] = 0.0;
	intmatgl[10] = (glfar + glnear) / (glfar - glnear);
	intmatgl[14] = -2.0 * glfar * glnear / (glfar - glnear);
	intmatgl[3] = 0.0;
	intmatgl[7] = 0.0;
	intmatgl[11] = 1.0;
	intmatgl[15] = 0.0;

	// SĂ̓_`
	intmatgl[10] = 0.0;
	intmatgl[14] = 0.0;

	dcMemory.CreateCompatibleDC(this->GetDC());
	bmInfo.bmiHeader.biSize = sizeof(bmInfo.bmiHeader);
	bmInfo.bmiHeader.biWidth = SIZEX;
	bmInfo.bmiHeader.biHeight = SIZEY;
	bmInfo.bmiHeader.biPlanes = 1;
	bmInfo.bmiHeader.biBitCount = 24;
	bmInfo.bmiHeader.biXPelsPerMeter = 0;
	bmInfo.bmiHeader.biYPelsPerMeter = 0;
	bmInfo.bmiHeader.biClrUsed = 0;
	bmInfo.bmiHeader.biClrImportant = 0;
	bmInfo.bmiHeader.biCompression = BI_RGB;
	bmInfo.bmiHeader.biSizeImage = 0;
	usage = DIB_RGB_COLORS;
	hBitmap = CreateDIBSection(dcMemory.GetSafeHdc(), &bmInfo, usage, (void**)&bitdata, NULL, 0);
	SelectObject(dcMemory.GetSafeHdc(), hBitmap);

	PIXELFORMATDESCRIPTOR pfd = 
	{
		sizeof (PIXELFORMATDESCRIPTOR),				// TCY
		1,
		PFD_DRAW_TO_BITMAP | PFD_SUPPORT_OPENGL,	// tO
		PFD_TYPE_RGBA,								// J[f[^
		24,											// rbg
		0, 0, 0, 0, 0, 0, 0, 0,						// Œ: RGBÃrbg
		0, 0, 0, 0,	0,								// AL~[Vobt@̃rbg(A`GCAXp)
		16,											// fvXobt@̃rbg (32bitƒx)
		0, 0,										// Œ: XeVE⏕obt@
		PFD_MAIN_PLANE,								// : 僌C^Cv
		0, 0, 0, 0,									// Œ
	};
	int nPixelFormat = ChoosePixelFormat(dcMemory.GetSafeHdc(), &pfd);
	BOOL bSuccess = SetPixelFormat(dcMemory.GetSafeHdc(), nPixelFormat, &pfd);

	m_hRC = ::wglCreateContext(dcMemory.GetSafeHdc());

	// OpenGL R}h𔭍sOɂ͂Ă
	::wglMakeCurrent(dcMemory.GetSafeHdc(), m_hRC);

	// r[|[g̐ݒ
	::glMatrixMode(GL_PROJECTION);
	::glLoadIdentity();
	::glLoadMatrixd(intmatgl);
	::glViewport(0, 0, SIZEX, SIZEY);
	::glMatrixMode(GL_MODELVIEW);
	::glLoadIdentity();
	::glLoadMatrixd(extmatgl);

	// 
	::glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	::glClearDepth(1.0f);
	::glEnable(GL_DEPTH_TEST);
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
	// ̑̐ݒ
	::glDisable(GL_LIGHTING);

	// `
	::glBegin(GL_POINTS);
	::glColor3d(1.0, 0.0, 0.0);
	for(i = 0; i < point3dnum; i++) {
		::glVertex3d(point3d[i*3 + 0], point3d[i*3 + 1], point3d[i*3 + 2]);
	}		
	::glEnd();
	
	::glFinish();

	::glDisable(GL_DEPTH_TEST);
	::glDisable(GL_LIGHTING);

	// OpenGL R}h𔭍sI炱Ă
	::wglMakeCurrent(dcMemory.GetSafeHdc(), 0);

	// 摜f[^Rs[
	for(y = 0; y < SIZEY; y++) {
		for(x = 0; x < SIZEX; x++) {
			i = (SIZEY - 1 - y) * (SIZEX*3 + (4-(SIZEX*3)%4)%4) + x * 3;
			j = 4*SIZEX*y + 4*x;
			b = bitdata[i + 0];
			g = bitdata[i + 1];
			r = bitdata[i + 2];
			screendata[j + 0] = b;
			screendata[j + 1] = g;
			screendata[j + 2] = r;
			screendata[j + 3] = 0;
		}
	}

	// 
	::wglDeleteContext(m_hRC);
	DeleteObject(hBitmap);
	dcMemory.DeleteDC();
	delete [] intmatgl;

	// 2摜Ƒ킹
	for(y = 0; y < SIZEY; y++) {
		for(x = 0; x < SIZEX; x++) {
			j = 4*SIZEX*y + 4*x;
			screendata[j + 0] /= 2;
			screendata[j + 1] /= 2;
			screendata[j + 2] /= 2;
			screendata[j + 3] /= 2;
		}
	}
	for(y = 0; y < SIZEY; y++) {
		for(x = 0; x < SIZEX; x++) {
			r = (int)imagedata[y*SIZEX*3 + x*3 + 0];
			g = (int)imagedata[y*SIZEX*3 + x*3 + 1];
			b = (int)imagedata[y*SIZEX*3 + x*3 + 2];
			r /= 2;
			g /= 2;
			b /= 2;
			screendata[SIZEX*4*y + 4*x + 0] += (unsigned char)b;
			screendata[SIZEX*4*y + 4*x + 1] += (unsigned char)g;
			screendata[SIZEX*4*y + 4*x + 2] += (unsigned char)r;
			screendata[SIZEX*4*y + 4*x + 3] += (unsigned char)0;
		}
	}
}

void CMiyaCalibView::OnExecOpen()
{
	CFileDialog *cfd;

	cfd = new CFileDialog(true, NULL, NULL,
		OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST,
		"Js(*.txt)|*.txt|SẴt@C (*.*)|*.*||",
		AfxGetApp()->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "Jst@CJ܂";
	if(cfd->DoModal() == IDOK) {
		ReadIntrinsic(cfd->GetPathName());
		processdone[MIYA_INTRINSIC] = true;
	}
	delete cfd;

	cfd = new CFileDialog(true, NULL, NULL,
		OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST,
		"摜t@C|*.bmp;*.dib;*.jpeg;*.jpg;*.jpe;*.png;*.pbm;*.pgm;*.ppm;*.pxm;*.pnm;*.sr;*.ras;*.tiff;*.tif;*.exr;*.jp2|SẴt@C (*.*)|*.*||",
		AfxGetApp()->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "摜t@CJ܂";
	if(cfd->DoModal() == IDOK) {
		ReadImage(cfd->GetPathName());
		processdone[MIYA_IMAGE] = true;
	}
	delete cfd;

	cfd = new CFileDialog(true, NULL, NULL,
		OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST,
		"Rf[^(*.obj)|*.obj|SẴt@C (*.*)|*.*||",
		AfxGetApp()->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "Rf[^t@CJ܂";
	if(cfd->DoModal() == IDOK) {
		ReadGeometry(cfd->GetPathName());
		processdone[MIYA_GEOMETRY] = true;
	}
	delete cfd;
}

void CMiyaCalibView::ReadIntrinsic(CString sFileName)
{
	CWaitCursor wait;
	CFile cf(sFileName, CFile::modeRead);
	CArchive ar(&cf, CArchive::load);
	CString sLine;
	CString str;

	ar.ReadString(sLine);
	cvmSet(intrinsic_matrix, 0, 0, atof(sLine.Left(sLine.Find(" "))));
	sLine = sLine.Mid(sLine.Find(" ") + 1);
	cvmSet(intrinsic_matrix, 0, 1, atof(sLine.Left(sLine.Find(" "))));
	sLine = sLine.Mid(sLine.Find(" ") + 1);
	cvmSet(intrinsic_matrix, 0, 2, atof(sLine));

	ar.ReadString(sLine);
	cvmSet(intrinsic_matrix, 1, 0, atof(sLine.Left(sLine.Find(" "))));
	sLine = sLine.Mid(sLine.Find(" ") + 1);
	cvmSet(intrinsic_matrix, 1, 1, atof(sLine.Left(sLine.Find(" "))));
	sLine = sLine.Mid(sLine.Find(" ") + 1);
	cvmSet(intrinsic_matrix, 1, 2, atof(sLine));

	ar.ReadString(sLine);
	cvmSet(intrinsic_matrix, 2, 0, atof(sLine.Left(sLine.Find(" "))));
	sLine = sLine.Mid(sLine.Find(" ") + 1);
	cvmSet(intrinsic_matrix, 2, 1, atof(sLine.Left(sLine.Find(" "))));
	sLine = sLine.Mid(sLine.Find(" ") + 1);
	cvmSet(intrinsic_matrix, 2, 2, atof(sLine));

	ar.Close();
	cf.Close();
}

void CMiyaCalibView::ReadImage(CString sFileName)
{
	CWaitCursor wait;
	int x, y;
	unsigned char r, g, b;
	int i;

	// 摜t@Cǂݍ
	IplImage* imagecv = cvLoadImage(sFileName);

	// m
	if(screendata != NULL) delete [] screendata;
	if(imagedata != NULL) delete [] imagedata;
	screendata = NULL;
	imagedata = NULL;
	SIZEX = imagecv->width;
	SIZEY = imagecv->height;
	imagedata = new unsigned char[3*SIZEX*SIZEY];
	if(imagedata == NULL) {
			AfxMessageBox("܂");
			return;
	}

	// f[^Rs[
	for(y = 0; y < SIZEY; y++) {
		for(x = 0; x < SIZEX; x++) {
			b = (unsigned char)imagecv->imageData[y * imagecv->widthStep + x * 3 + 0];
			g = (unsigned char)imagecv->imageData[y * imagecv->widthStep + x * 3 + 1];
			r = (unsigned char)imagecv->imageData[y * imagecv->widthStep + x * 3 + 2];
			imagedata[y * SIZEX * 3 + x * 3 + 0] = r;
			imagedata[y * SIZEX * 3 + x * 3 + 1] = g;
			imagedata[y * SIZEX * 3 + x * 3 + 2] = b;
		}
	}
	cvReleaseImage(&imagecv);

	// m
	screendata = new unsigned char[4*SIZEX*SIZEY];
	if(screendata == NULL) {
			AfxMessageBox("܂");
			return;
	}
	for(i = 0; i < 4 * SIZEX * SIZEY; i++) screendata[i] = 0;
}

void CMiyaCalibView::ReadGeometry(CString sFileName)
{
	CWaitCursor wait;
	CFile cf(sFileName, CFile::modeRead);
	CArchive ar(&cf, CArchive::load);
	CString sLine;
	int i;
	double r;
	double* point3dtemp;

	if(point3d != NULL) delete [] point3d;
	if(point3dproj != NULL) delete [] point3dproj;
	point3d = NULL;
	point3dproj = NULL;
	point3dtemp = NULL;
	point3dtemp = new double[POINT3DMAX*3];
	if(point3dtemp == NULL) {
		AfxMessageBox("܂");
		return;
	}

	// t@Cǂݍ
	point3dnum = 0;
	while(ar.ReadString(sLine)) {
		if(sLine.Left(2) == "v ") {
			if(point3dnum >= POINT3DMAX) {
				AfxMessageBox("_̐đSẴf[^ǂݍނƂo܂ł");
				break;
			}
			sLine = sLine.Mid(2);
			point3dtemp[point3dnum * 3 + 0] = atof(sLine.Left(sLine.Find(" ")));
			sLine = sLine.Mid(sLine.Find(" ") + 1);
			point3dtemp[point3dnum * 3 + 1] = atof(sLine.Left(sLine.Find(" ")));
			sLine = sLine.Mid(sLine.Find(" ") + 1);
			point3dtemp[point3dnum * 3 + 2] = atof(sLine);
			point3dnum++;
		}
	}
	ar.Close();
	cf.Close();

	// f[^̃Rs[
	point3d = new double[point3dnum*3];
	if(point3d == NULL) {
			AfxMessageBox("܂");
			return;
	}
	for(i = 0; i < point3dnum; i++) {
		point3d[i*3+0] = point3dtemp[i*3+0];
		point3d[i*3+1] = point3dtemp[i*3+1];
		point3d[i*3+2] = point3dtemp[i*3+2];
	}
	delete [] point3dtemp;
	point3dproj = new int[point3dnum*2];
	if(point3dproj == NULL) {
			AfxMessageBox("܂");
			return;
	}

	// dŠvZ
	centerx = 0.0;
	centery = 0.0;
	centerz = 0.0;
	for(i = 0; i < point3dnum; i++) {
		centerx += point3d[i*3 + 0];
		centery += point3d[i*3 + 1];
		centerz += point3d[i*3 + 2];
	}
	centerx /= (double)point3dnum;
	centery /= (double)point3dnum;
	centerz /= (double)point3dnum;

	// TCY̌vZ
	scale = EPS;
	for(i = 0; i < point3dnum; i++) {
		r = NORM(point3d[i*3 + 0] - centerx, point3d[i*3 + 1] - centery, point3d[i*3 + 2] - centerz);
		if(r > scale) scale = r;
	}
}

void CMiyaCalibView::OnExecTarget()
{
	CFileDialog *cfd;

	cfd = new CFileDialog(true, NULL, NULL,
		OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST,
		"摜t@C|*.bmp;*.dib;*.jpeg;*.jpg;*.jpe;*.png;*.pbm;*.pgm;*.ppm;*.pxm;*.pnm;*.sr;*.ras;*.tiff;*.tif;*.exr;*.jp2|SẴt@C (*.*)|*.*||",
		AfxGetApp()->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "摜t@CJ܂";
	if(cfd->DoModal() == IDOK) {
		ReadImage(cfd->GetPathName());
		processdone[MIYA_IMAGE] = true;
	}
	delete cfd;

	cfd = new CFileDialog(true, NULL, NULL,
		OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST,
		"Rf[^(*.obj)|*.obj|SẴt@C (*.*)|*.*||",
		AfxGetApp()->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "Rf[^t@CJ܂";
	if(cfd->DoModal() == IDOK) {
		ReadGeometry(cfd->GetPathName());
		processdone[MIYA_GEOMETRY] = true;
	}
	delete cfd;

	CreateImages();
	Invalidate();
}

void CMiyaCalibView::OnExecSave()
{
	CWinApp* theApp = AfxGetApp();
	CFileDialog *cfd;
	CString s;

	cfd = new CFileDialog(FALSE, "txt", "extrinsic.txt",
		OFN_EXPLORER | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
		"JOs (*.txt)|*.txt|SẴt@C (*.*)|*.*||", theApp->GetMainWnd());
	cfd->m_ofn.lpstrTitle = "JOst@Cۑ܂";
	if(cfd->DoModal() == IDOK) WriteExtrinsic(cfd->GetPathName());
	delete cfd;
}

void CMiyaCalibView::WriteExtrinsic(CString sFileName)
{
	CWaitCursor wait;
	CFile cf(sFileName, CFile::modeWrite | CFile::modeCreate);
	CArchive ar(&cf, CArchive::store);
	CString str;

	str.Format("%1.5f %1.5f %1.5f %1.5f\n", extmatgl[0], extmatgl[4], extmatgl[8], extmatgl[12]);
	ar.WriteString(str);
	str.Format("%1.5f %1.5f %1.5f %1.5f\n", extmatgl[1], extmatgl[5], extmatgl[9], extmatgl[13]);
	ar.WriteString(str);
	str.Format("%1.5f %1.5f %1.5f %1.5f\n", extmatgl[2], extmatgl[6], extmatgl[10], extmatgl[14]);
	ar.WriteString(str);

	ar.Close();
	cf.Close();
}

void CMiyaCalibView::OnDebugTest1()
{
	CWaitCursor wait;
	CvMat* src_points;
	CvMat* dst_points;
	CvMat* homography;
	int inxlist;
	int plane;
	double* plane2d;
	int inx3d;
	double origx, origy;
	double projx, projy, projz;
	bool flag;
	int i;
	double ax, ay, az;
	double bx, by, bz;
	double cz;
	CString str;
	RECT rect;
	CBrush brush;

	src_points = NULL;
	dst_points = NULL;
	homography = NULL;
	plane2d = NULL;
	src_points = cvCreateMat(4, 2, CV_64FC1);
	dst_points = cvCreateMat(4, 2, CV_64FC1);
	homography = cvCreateMat(3, 3, CV_64FC1);
	plane2d = new double[4*2];
	if(src_points == NULL ||
		dst_points == NULL ||
		homography == NULL ||
		plane2d == NULL) {
			AfxMessageBox("܂");
			return;
	}

	CalcIndex();

	inxlist = 0;
	for(plane = 0; plane < 3; plane++) {
		if(plane == 0) brush.CreateSolidBrush(RGB(255,0,0));
		if(plane == 1) brush.CreateSolidBrush(RGB(0,255,0));
		if(plane == 2) brush.CreateSolidBrush(RGB(0,0,255));

		// lp`ݒ
		cvmSet(src_points, 0, 0, (double)corres3d[plane*4*2 + 0*2 + 0]);
		cvmSet(src_points, 0, 1, (double)corres3d[plane*4*2 + 0*2 + 1]);
		cvmSet(src_points, 1, 0, (double)corres3d[plane*4*2 + 1*2 + 0]);
		cvmSet(src_points, 1, 1, (double)corres3d[plane*4*2 + 1*2 + 1]);
		cvmSet(src_points, 2, 0, (double)corres3d[plane*4*2 + 2*2 + 0]);
		cvmSet(src_points, 2, 1, (double)corres3d[plane*4*2 + 2*2 + 1]);
		cvmSet(src_points, 3, 0, (double)corres3d[plane*4*2 + 3*2 + 0]);
		cvmSet(src_points, 3, 1, (double)corres3d[plane*4*2 + 3*2 + 1]);
		plane2d[0*2 + 0] = (double)corres2d[plane*4*2 + 0*2 + 0];
		plane2d[0*2 + 1] = (double)corres2d[plane*4*2 + 0*2 + 1];
		plane2d[1*2 + 0] = (double)corres2d[plane*4*2 + 1*2 + 0];
		plane2d[1*2 + 1] = (double)corres2d[plane*4*2 + 1*2 + 1];
		plane2d[2*2 + 0] = (double)corres2d[plane*4*2 + 2*2 + 0];
		plane2d[2*2 + 1] = (double)corres2d[plane*4*2 + 2*2 + 1];
		plane2d[3*2 + 0] = (double)corres2d[plane*4*2 + 3*2 + 0];
		plane2d[3*2 + 1] = (double)corres2d[plane*4*2 + 3*2 + 1];
		cvmSet(dst_points, 0, 0, plane2d[0*2 + 0]);
		cvmSet(dst_points, 0, 1, plane2d[0*2 + 1]);
		cvmSet(dst_points, 1, 0, plane2d[1*2 + 0]);
		cvmSet(dst_points, 1, 1, plane2d[1*2 + 1]);
		cvmSet(dst_points, 2, 0, plane2d[2*2 + 0]);
		cvmSet(dst_points, 2, 1, plane2d[2*2 + 1]);
		cvmSet(dst_points, 3, 0, plane2d[3*2 + 0]);
		cvmSet(dst_points, 3, 1, plane2d[3*2 + 1]);

		// zOtB[vZ
		cvFindHomography(src_points, dst_points, homography);

		// 3D_2D_̃Xg
		for(inx3d = 0; inx3d < point3dnum; inx3d++) {
			origx = (double)point3dproj[inx3d*2 + 0];
			origy = (double)point3dproj[inx3d*2 + 1];
			if(origx >= 0 && origy >= 0) {
				// Ή_vZ
				projx = cvmGet(homography, 0, 0) * origx + cvmGet(homography, 0, 1) * origy + cvmGet(homography, 0, 2);
				projy = cvmGet(homography, 1, 0) * origx + cvmGet(homography, 1, 1) * origy + cvmGet(homography, 1, 2);
				projz = cvmGet(homography, 2, 0) * origx + cvmGet(homography, 2, 1) * origy + cvmGet(homography, 2, 2);
				projx /= projz;
				projy /= projz;

				// lp`̓
				flag = true;
				for(i = 0; i < 4; i++) {
					ax = plane2d[((i+1)%4) * 2 + 0] - plane2d[i * 2 + 0];
					ay = plane2d[((i+1)%4) * 2 + 1] - plane2d[i * 2 + 1];
					az = 0.0;
					bx = projx - plane2d[i * 2 + 0];
					by = projy - plane2d[i * 2 + 1];
					bz = 0.0;
					cz = ax * by - ay * bx;
					if(cz > 0.0) flag = false;
				}

				// Xgɒǉ
				if(flag) {
					rect.top = (int)projy - 1;
					rect.bottom = (int)projy + 1;
					rect.left = (int)projx - 1;
					rect.right = (int)projx + 1;
					this->GetDC()->FillRect(&rect, &brush);
				}
			}
		}
		brush.DeleteObject();
	}

	// 
	cvReleaseMat(&src_points);
	cvReleaseMat(&dst_points);
	cvReleaseMat(&homography);
	delete [] plane2d;
}

void CMiyaCalibView::OnDebugTest2()
{
	CWaitCursor wait;
	CvMat* src_points;
	CvMat* dst_points;
	CvMat* homography;
	int inxlist;
	int plane;
	double* plane2d;
	int inx3d;
	double origx, origy;
	double projx, projy, projz;
	bool flag;
	int i;
	double ax, ay, az;
	double bx, by, bz;
	double cz;
	double* caliblist2;
	double* caliblist3;
	CvMat* object_points;
	CvMat* image_points;
	CString str;

	src_points = NULL;
	dst_points = NULL;
	homography = NULL;
	plane2d = NULL;
	caliblist2 = NULL;
	caliblist3 = NULL;
	src_points = cvCreateMat(4, 2, CV_64FC1);
	dst_points = cvCreateMat(4, 2, CV_64FC1);
	homography = cvCreateMat(3, 3, CV_64FC1);
	plane2d = new double[4*2];
	caliblist2 = new double[point3dnum*2];
	caliblist3 = new double[point3dnum*3];
	if(src_points == NULL ||
		dst_points == NULL ||
		homography == NULL ||
		plane2d == NULL ||
		caliblist2 == NULL ||
		caliblist3 == NULL) {
			AfxMessageBox("܂");
			return;
	}

	CalcIndex();

	inxlist = 0;
	for(plane = 0; plane < 3; plane++) {
		// lp`ݒ
		cvmSet(src_points, 0, 0, (double)corres3d[plane*4*2 + 0*2 + 0]);
		cvmSet(src_points, 0, 1, (double)corres3d[plane*4*2 + 0*2 + 1]);
		cvmSet(src_points, 1, 0, (double)corres3d[plane*4*2 + 1*2 + 0]);
		cvmSet(src_points, 1, 1, (double)corres3d[plane*4*2 + 1*2 + 1]);
		cvmSet(src_points, 2, 0, (double)corres3d[plane*4*2 + 2*2 + 0]);
		cvmSet(src_points, 2, 1, (double)corres3d[plane*4*2 + 2*2 + 1]);
		cvmSet(src_points, 3, 0, (double)corres3d[plane*4*2 + 3*2 + 0]);
		cvmSet(src_points, 3, 1, (double)corres3d[plane*4*2 + 3*2 + 1]);
		plane2d[0*2 + 0] = (double)corres2d[plane*4*2 + 0*2 + 0];
		plane2d[0*2 + 1] = (double)corres2d[plane*4*2 + 0*2 + 1];
		plane2d[1*2 + 0] = (double)corres2d[plane*4*2 + 1*2 + 0];
		plane2d[1*2 + 1] = (double)corres2d[plane*4*2 + 1*2 + 1];
		plane2d[2*2 + 0] = (double)corres2d[plane*4*2 + 2*2 + 0];
		plane2d[2*2 + 1] = (double)corres2d[plane*4*2 + 2*2 + 1];
		plane2d[3*2 + 0] = (double)corres2d[plane*4*2 + 3*2 + 0];
		plane2d[3*2 + 1] = (double)corres2d[plane*4*2 + 3*2 + 1];
		cvmSet(dst_points, 0, 0, plane2d[0*2 + 0]);
		cvmSet(dst_points, 0, 1, plane2d[0*2 + 1]);
		cvmSet(dst_points, 1, 0, plane2d[1*2 + 0]);
		cvmSet(dst_points, 1, 1, plane2d[1*2 + 1]);
		cvmSet(dst_points, 2, 0, plane2d[2*2 + 0]);
		cvmSet(dst_points, 2, 1, plane2d[2*2 + 1]);
		cvmSet(dst_points, 3, 0, plane2d[3*2 + 0]);
		cvmSet(dst_points, 3, 1, plane2d[3*2 + 1]);

		// zOtB[vZ
		cvFindHomography(src_points, dst_points, homography);

		// 3D_2D_̃Xg
		for(inx3d = 0; inx3d < point3dnum; inx3d++) {
			origx = (double)point3dproj[inx3d*2 + 0];
			origy = (double)point3dproj[inx3d*2 + 1];
			if(origx >= 0 && origy >= 0) {
				// Ή_vZ
				projx = cvmGet(homography, 0, 0) * origx + cvmGet(homography, 0, 1) * origy + cvmGet(homography, 0, 2);
				projy = cvmGet(homography, 1, 0) * origx + cvmGet(homography, 1, 1) * origy + cvmGet(homography, 1, 2);
				projz = cvmGet(homography, 2, 0) * origx + cvmGet(homography, 2, 1) * origy + cvmGet(homography, 2, 2);
				projx /= projz;
				projy /= projz;

				// lp`̓
				flag = true;
				for(i = 0; i < 4; i++) {
					ax = plane2d[((i+1)%4) * 2 + 0] - plane2d[i * 2 + 0];
					ay = plane2d[((i+1)%4) * 2 + 1] - plane2d[i * 2 + 1];
					az = 0.0;
					bx = projx - plane2d[i * 2 + 0];
					by = projy - plane2d[i * 2 + 1];
					bz = 0.0;
					cz = ax * by - ay * bx;
					if(cz > 0.0) flag = false;
				}

				// Xgɒǉ
				if(flag) {
					caliblist2[inxlist*2 + 0] = projx;
					caliblist2[inxlist*2 + 1] = projy;
					caliblist3[inxlist*3 + 0] = point3d[inx3d*3 + 0];
					caliblist3[inxlist*3 + 1] = point3d[inx3d*3 + 1];
					caliblist3[inxlist*3 + 2] = point3d[inx3d*3 + 2];
					inxlist++;
				}
			}
		}
	}

	// Lu[Vpf[^̃̊m
	object_points = NULL;
	image_points = NULL;
	object_points = cvCreateMat(inxlist, 3, CV_64FC1);
	image_points = cvCreateMat(inxlist, 2, CV_64FC1);
	if(object_points == NULL ||
		image_points == NULL) {
			AfxMessageBox("܂");
			return;
	}

	// Lu[Vpf[^ݒ
	for(i = 0; i < inxlist; i++) {
		cvmSet(object_points, i, 0, caliblist3[i*3 + 0]);
		cvmSet(object_points, i, 1, caliblist3[i*3 + 1]);
		cvmSet(object_points, i, 2, caliblist3[i*3 + 2]);
		cvmSet(image_points, i, 0, caliblist2[i*2 + 0]);
		cvmSet(image_points, i, 1, caliblist2[i*2 + 1]);
	}

	// file save
	CFile cf("debug.txt", CFile::modeWrite | CFile::modeCreate);
	CArchive ar(&cf, CArchive::store);
	str = "3dx 3dy 3dz 2dx 2dy\n";
	ar.WriteString(str);
	for(i = 0; i < inxlist; i++) {
		str.Format("%1.3f %1.3f %1.3f %1.1f %1.1f\n",
			cvmGet(object_points, i, 0), cvmGet(object_points, i, 1), cvmGet(object_points, i, 2),
			cvmGet(image_points, i, 0), cvmGet(image_points, i, 1));
		ar.WriteString(str);
	}
	ar.Close();
	cf.Close();

	// 
	cvReleaseMat(&src_points);
	cvReleaseMat(&dst_points);
	cvReleaseMat(&homography);
	cvReleaseMat(&object_points);
	cvReleaseMat(&image_points);
	delete [] plane2d;
	delete [] caliblist2;
	delete [] caliblist3;

	// ㏈
	processdone[MIYA_CALIB] = true;
	viewmode = MIYA_CALIB;
	CreateImages();
	Invalidate();
}
